
import flash.MovieClip;

class Layer
{
  private var FContainer: MovieClip;

  private var FXScale: Int;
  private var FYScale: Int;
  private var FTileW: Int;
  private var FTileH: Int;
  private var FMapW: Int;
  private var FMapH: Int;
  private var FBufW: Int;
  private var FBufH: Int;
  private var FX: Int;
  private var FY: Int;
  private var FFirstTime: Bool;
  private var iFTileMap: Array<Array<Int>>;
  private var mcFTileMap: Array<Array<MovieClip>>;
  private var FData: Array<Array<Int>>;
  private var FTileSet: String;

  public function data (): Array<Array<Int>>
  {
    return [[0]];
  }

  public function init (Container: MovieClip, XScale, YScale: Int)
  {
    var i: Int;
    var j: Int;

    FContainer = Container;
    FXScale = XScale;
    FYScale = YScale;

    FTileW = Math.floor (FTileW * FXScale / 100);
    FTileH = Math.floor (FTileH * FYScale / 100);
    FBufW = Math.floor ((flash.Stage.width + FTileW - 1) / FTileW) + 2;
    FBufH = Math.floor ((flash.Stage.height + FTileH - 1) / FTileH) + 2;

    iFTileMap = new Array ();
    mcFTileMap = new Array ();
    for (j in 0...FBufH)
    {
      iFTileMap[j] = new Array ();
      mcFTileMap[j] = new Array ();
      for (i in 0...FBufW)
      {
        iFTileMap[j][i] = -1000000;
        mcFTileMap[j][i] = FContainer.createEmptyMovieClip ("mc_" + j + "_" + i, FContainer.getNextHighestDepth ());
      }
    }
    FData = data ();
    FX = 0;
    FY = 0;
    FFirstTime = true;
  }

  public function Width ()
  {
    return FMapW * FTileW;
  }

  public function Height ()
  {
    return FMapH * FTileH;
  }

  public function MoveTo (X, Y: Int)
  {
    var i: Int;
    var j: Int;
    var k: Int;
    var MC: MovieClip;
    var x: Int;
    var y: Int;
    var mapx: Int;
    var mapy: Int;
    var tilex: Int;
    var tiley: Int;
    var count: Int;
    var limit: Int;

    if (FFirstTime)
      limit = FBufH * FBufW;
    else
      limit = Math.round (2 * Math.abs (X - FX) + 2 * Math.abs (Y - FY));

    FX = X;
    FY = Y;

    count = 0;
    for (j in 0...FBufH)
    {
      y = (Math.floor (FY / FTileH) + j - 1);
      mapy = y % FBufH;
      tiley = y % FMapH;

      for (i in 0...FBufW)
      {
        x = (Math.floor (FX / FTileW) + i - 1);
        mapx = x % FBufW;
        tilex = x % FMapW;

        k = FData[tiley][tilex];
        MC = mcFTileMap[mapy][mapx];
        if (count < limit)
        {
          if (k != iFTileMap[mapy][mapx])
          {
            if (k == 0)
              MC._visible = false;
            else
              if (iFTileMap[mapy][mapx] == 0)
                MC._visible = true;
            if (k < 0)
              MC.attachMovie (FTileSet + "Clip" + (-k - 1), "mc_" + mapx + "_" + mapy, FContainer.getNextHighestDepth ())
            else
              MC.attachMovie (FTileSet + (k - 1), "mc_" + mapx + "_" + mapy, FContainer.getNextHighestDepth ());
            iFTileMap[mapy][mapx] = k;
            count++;
          }
        }
        MC._x = (x * FTileW) - FX;
        MC._y = (y * FTileH) - FY;

        MC._xscale = FXScale;
        MC._yscale = FYScale;
      }
    }

    FFirstTime = false;
  }

}
